#ifndef _USB_IP_H_
#define _USB_IP_H_




#define SECTION_ID_DEVICE_DESCRIPTOR_SS               0
#define SECTION_ID_DEVICE_DESCRIPTOR_HS               1
#define SECTION_ID_DEVICE_DESCRIPTOR_FS               2
#define SECTION_ID_CUSTOMER_DEVICE_DESCRIPTOR_SS      3
#define SECTION_ID_CUSTOMER_DEVICE_DESCRIPTOR_HS      4
#define SECTION_ID_CUSTOMER_DEVICE_DESCRIPTOR_FS      5



#define SECTION_ID_DEVICE_QUALIFER_DESCRIPTOR         6

// For Super Speed
#define SECTION_ID_CONFIGURE_SS_BASE                  7
#define SECTION_ID_CONFIGURE_SS_CDROM                 8
#define SECTION_ID_CONFIGURE_SS_HOSTLINK              9
#define SECTION_ID_CONFIGURE_SS_GRABBER               10
#define SECTION_ID_CONFIGURE_SS_CUSTOMER              11

// For High Speed
#define SECTION_ID_CONFIGURE_HS_BASE                  14
#define SECTION_ID_CONFIGURE_HS_CDROM                 15
#define SECTION_ID_CONFIGURE_HS_HOSTLINK              16
#define SECTION_ID_CONFIGURE_HS_GRABBER               17
#define SECTION_ID_CONFIGURE_HS_CUSTOMER              18


// For Full Speed
#define SECTION_ID_CONFIGURE_FS_BASE                  21
#define SECTION_ID_CONFIGURE_FS_CDROM                 22
#define SECTION_ID_CONFIGURE_FS_HOSTLINK              23
#define SECTION_ID_CONFIGURE_FS_GRABBER               24
#define SECTION_ID_CONFIGURE_FS_CUSTOMER              25

#define SECTION_ID_BOS_DESCRIPTOR                     28

// For Video related tables 
#define SECTION_ID_MJPG_HUFFMAN_TABLE                 31
#define SECTION_ID_ZIG_ZAG_SCAN_TABLE                 32
#define SECTION_ID_DQT_Y_TABLE                        33
#define SECTION_ID_DQT_CBCR_TABLE                     34
#define SECTION_ID_MJPG_HEADER_TABLE                  35

#define SECTION_ID_CODEC_VTIME_TABLE                  36


#define ENDPOINT_NUMBER_AUDIO_ISO_IN                0x8A


#define VIDEO_DEVICE_CLASS_VERSION                  0x0100
#define AUDIO_DEVICE_CLASS_VERSION                  0x0100

#define TERMINAL_ID_CAMERA                          0x01
#define TERMINAL_ID_VIDEO_STREAMING                 0x02

#define UNIT_ID_PROCESSING                          0x03

#define UNIT_ID_EXTENSION                           0x04

#define TERMINAL_ID_MICROPHONE                      0x01
#define TERMINAL_ID_AUDIO_STREAMING                 0x02

#define UNIT_ID_FEATURE                             0x03


#define FORMAT_INDEX_MJPEG                          0x01
#define FORMAT_INDEX_UNCOMPRESSED                   0x02

#define FRAME_INDEX_MJPEG                           0x01
#define FRAME_INDEX_UNCOMPRESSED                    0x01


//For select different PID
#define FW_PID_FUNCTION_CDROM                       0x7010
#define FW_PID_FUNCTION_CDROM_HOSTLINK              0x7012
#define FW_PID_FUNCTION_CDROM_GRABBER               0x7013
#define FW_PID_FUNCTION_CDROM_HOSTLINK_GRABBER      0x7014
#define FW_PID_FUNCTION_HOSTLINK                    0x7015
#define FW_PID_FUNCTION_GRABBER                     0x7016
#define FW_PID_FUNCTION_HOSTLINK_GRABBER            0x7017
#define FW_PID_FUNCTION_CUSTOM                      0x7018


VOID USBIP_HandleInterrupt(
    BOOL bPrimary
    );


VOID USBIP_EnableInterrupt(
    BOOL bPrimary
    );




VOID USBIP_EnableDisable(
    BOOL    bPrimary,
    BOOL    bEnable
    );


VOID USBIP_ReceiveEp0Data(
    BOOL    bPrimary,
    PU8     pBuffer,
    U16     Length
    );


VOID USBIP_SendEp0Data(
    BOOL    bPrimary,
    PU8     pBuffer,
    U16     Length
    );


VOID USBIP_StallEndpoint(
    BOOL    bPrimary,
    U8      EpIndex
    );


VOID USBIP_ClearStallEndpoint(
    BOOL    bPrimary,
    U8      EpIndex
    );


#endif